package com.sie.ems.mobile.process;

package ..deTemp.1747043285444;

import com.eos.foundation.data.DataObjectUtil;
import com.eos.foundation.database.DatabaseExt;
import com.eos.foundation.database.DatabaseUtil;
import com.eos.system.annotation.Bizlet;
import com.primeton.workflow.api.transaction.TransactionService;
import com.primeton.workflow.service.framework.WFServiceFactory;
import com.sie.ems.io.kaili.ocr.OcrIoRequest;
import com.sie.ems.mobile.NoteUtils;
import com.sie.ems.util.DataObjectUtil;
import com.sie.ems.util.HashMapUtil;
import com.sie.ems.util.JavaCallLogic;
import commonj.sdo.DataObject;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang.StringUtils;
import org.codehaus.jettison.json.JSONArray;
import org.codehaus.jettison.json.JSONException;
import org.codehaus.jettison.json.JSONObject;

@Bizlet("")
public class InvoiceTicketClip {
  @Bizlet("")
  public DataObject deleteInvoice(String invoiceId) {
    String msg = "";
    try {
      DataObject emsIvTicketClip = 
        DataObjectUtil.createDataObject("com.sie.ems.mobile.note.EmsIvTicketClip");
      emsIvTicketClip.set("imageOcrId", invoiceId);
      DatabaseUtil.deleteByTemplate("default", emsIvTicketClip);
      DataObject emsIvTicketClipList = 
        DataObjectUtil.createDataObject("com.sie.ems.mobile.note.EmsIvTicketClipList");
      emsIvTicketClipList.set("imageOcrId", invoiceId);
      DatabaseUtil.deleteByTemplate("default", emsIvTicketClipList);
      DataObject tempFile = 
        DataObjectUtil.createDataObject("com.primeton.das.datatype.AnyType");
      tempFile.set("imageOcrId", invoiceId);
      Object[] objs = DatabaseExt.queryByNamedSql("default", 
          "com.sie.ems.mobile.ticketClip.queryDelFiles", tempFile);
      DataObject fileInfo = 
        DataObjectUtil.createDataObject("com.sie.ems.mobile.note.EmsIvTicketClipFile");
      fileInfo.set("imageOcrId", invoiceId);
      DatabaseUtil.deleteByTemplate("default", fileInfo);
      List<DataObject> delFiles = new ArrayList<DataObject>();
      CollectionUtils.addAll(delFiles, objs);
      for (DataObject del : delFiles) {
        Object[] params = new Object[1];
        params[0] = del.getString("FILE_URL");
        try {
          JavaCallLogic.callLogicBusiness(
              "com.sie.ems.util.am.deleteYxFile", params);
          System.out.println("删除附件=" + del.getString("FILE_URL"));
        } catch (Throwable e) {
          e.printStackTrace();
        } 
      } 
    } catch (Exception e) {
      e.printStackTrace();
      msg = "异常: " + e.getMessage();
      return NoteUtils.returnMsg(false, msg);
    } 
    return NoteUtils.returnMsg(true, "删除成功");
  }
  
  @Bizlet("")
  public DataObject addInvoice(DataObject[] invoiceInfo, String userId) {
    String msg = "";
    boolean state = true;
    DataObject emsIvTicketClip = null;
    String imageidString = "";
    List<DataObject> listFiles = new ArrayList<DataObject>();
    byte b;
    int i;
    DataObject[] arrayOfDataObject;
    for (i = (arrayOfDataObject = invoiceInfo).length, b = 0; b < i; ) {
      DataObject dataObj = arrayOfDataObject[b];
      Object[] listsForOcrL = (Object[])dataObj
        .get("emsYxApplyOcrLists");
      if (listsForOcrL != null && listsForOcrL.length > 1) {
        DataObject returnMsg = insertTickeForMoreTate(dataObj, 
            userId);
        state = returnMsg.getBoolean("state");
        msg = String.valueOf(msg) + returnMsg.getString("msg");
      } else {
        emsIvTicketClip = 
          DataObjectUtil.createDataObject("com.sie.ems.mobile.note.EmsIvTicketClip");
        TransactionService manager = 
          (TransactionService)WFServiceFactory.getService(TransactionService.class);
        manager.begin();
        try {
          emsIvTicketClip.setString("invoiceCode", 
              dataObj.getString("invoiceCode"));
          emsIvTicketClip.setString("invoiceNo", 
              dataObj.getString("invoiceNo"));
          DataObject[] objs = DatabaseUtil.queryEntitiesByTemplate(
              "default", emsIvTicketClip);
          DataObject emsEinvs = 
            DataObjectUtil.createDataObject("com.sie.ems.dataset.ec.EmsEcFeeEinv");
          emsEinvs.setString("eCode", dataObj.getString("invoiceCode"));
          emsEinvs.setString("eNum", dataObj.getString("invoiceNo"));
          DataObject[] einvs = DatabaseUtil.queryEntitiesByTemplate(
              "default", emsEinvs);
          if ((objs != null && objs.length > 0) || (
            einvs != null && einvs.length > 0)) {
            msg = String.valueOf(msg) + "发票号码：" + dataObj.getString("invoiceNo") + 
              "上传失败(已存在)；";
            state = false;
            manager.rollback();
            Object[] objFiles = (Object[])dataObj.get("fileInfo");
            byte b1;
            int j;
            Object[] arrayOfObject1;
            for (j = (arrayOfObject1 = objFiles).length, b1 = 0; b1 < j; ) {
              Object obj = arrayOfObject1[b1];
              HashMap map = (HashMap)obj;
              Iterator<Map.Entry> it = map.entrySet().iterator();
              while (it.hasNext()) {
                Map.Entry entry = it.next();
                String key = (String)entry.getKey();
                String value = (String)entry.getValue();
                DataObject data = 
                  DataObjectUtil.createDataObject("com.primeton.das.datatype.AnyType");
                if (StringUtils.equals("fileName", key)) {
                  data.set("fileName", value);
                  listFiles.add(data);
                } 
                if (StringUtils.equals("fileUrl", key)) {
                  data.set("fileUrl", value);
                  listFiles.add(data);
                } 
              } 
              b1++;
            } 
          } else {
            msg = String.valueOf(msg) + "发票号码：" + dataObj.getString("invoiceNo") + "保存成功，";
            if (StringUtils.isBlank(dataObj
                .getString("deductibleamount")) || 
              dataObj.getString("deductibleamount").equals(
                "null"))
              dataObj.set("deductibleamount", Integer.valueOf(0)); 
            if (StringUtils.isBlank(dataObj.getString("totalAmount")) || 
              dataObj.getString("totalAmount").equals("null"))
              dataObj.set("totalAmount", Integer.valueOf(0)); 
            if (StringUtils.isBlank(dataObj.getString("taxRate")) || 
              dataObj.getString("taxRate").equals("null"))
              dataObj.set("taxRate", Integer.valueOf(0)); 
            if (StringUtils.isBlank(dataObj.getString("taxAmount")) || 
              dataObj.getString("taxAmount").equals("null"))
              dataObj.set("taxAmount", Integer.valueOf(0)); 
            if (StringUtils.isBlank(dataObj.getString("amount")) || 
              dataObj.getString("amount").equals("null"))
              dataObj.set("amount", Integer.valueOf(0)); 
            if (StringUtils.isBlank(dataObj.getString("otherTax")) || 
              dataObj.getString("otherTax").equals("null"))
              dataObj.set("otherTax", Integer.valueOf(0)); 
            String code = dataObj.getString("invoiceTypeCode");
            if (code.equals("999"))
              dataObj.set("attribute3", Long.valueOf(Long.parseLong(code))); 
            String mark = dataObj.getString("electronicMark");
            if (code.equals("301") && "1".equals(mark)) {
              dataObj.set("invoiceTypeCode", "aaa");
              dataObj.set("invoiceType", "铁路电子客票");
            } 
            dataObj.getString("invoiceCheckCode");
            dataObj.set("attribute10", 
                dataObj.getString("invoiceCheckCode"));
            dataObj.set("ticketStatus", "N");
            try {
              Date date = dataObj.getDate("invoiceDate");
            } catch (Exception e) {
              System.err.println("日期数据异常" + e + "已做处理，设为空");
              dataObj.set("invoiceDate", null);
            } 
            dataObj.set("originalInvoiceNo", 
                dataObj.getString("invoiceNo"));
            emsIvTicketClip = DataObjectUtil.convertDataObject(dataObj, 
                "com.sie.ems.mobile.note.EmsIvTicketClip", false);
            DataObjectUtil.setIdBySequence(
                emsIvTicketClip, "imageOcrId", 
                "EMS_IV_TICKET_CLIP_S");
            NoteUtils.setWhoFieldValue(emsIvTicketClip, "imageOcrId", 
                userId);
            emsIvTicketClip.setString("ocrReimType", 
                dataObj.getString("taxInvTypeId"));
            emsIvTicketClip.setString("taxInvTypeId", null);
            String taxinvtypeidname = "f";
            try {
              taxinvtypeidname = dataObj
                .getString("taxinvtypeidname");
            } catch (Exception e) {
              taxinvtypeidname = "s";
            } 
            DataObject param = 
              DataObjectUtil.createDataObject("com.primeton.das.datatype.AnyType");
            if (dataObj.getString("invoiceType").indexOf("增值税电子普通发票") > -1) {
              param.set("invoiceTypeCode", 
                  dataObj.getString("invoiceTypeCode"));
              param.set("taxRate", Double.valueOf(dataObj.getDouble("taxRate") * 100.0D));
              Object[] arrayOfObject = (Object[])dataObj
                .get("emsYxApplyOcrLists");
              for (int j = 0; j < arrayOfObject.length; j++) {
                HashMap hashMap = (HashMap)arrayOfObject[j];
                param.set("attribute1", hashMap.get("goods"));
                Object[] objArr = 
                  DatabaseExt.queryByNamedSql(
                    "default", 
                    "com.sie.ems.mobile.ticketClip.queryOcrTypeId", 
                    param);
                if (objArr.length > 0) {
                  emsIvTicketClip.setString("taxInvTypeId", (
                      (DataObject)objArr[0])
                      .getString("OCR_TYPE_ID"));
                  break;
                } 
              } 
            } else {
              param.set("invoiceTypeCode", 
                  dataObj.getString("invoiceTypeCode"));
              Object[] objArr = DatabaseExt.queryByNamedSql(
                  "default", 
                  "com.sie.ems.mobile.ticketClip.queryOcrTypeId", 
                  param);
              if (objArr.length == 0) {
                emsIvTicketClip.setString("taxInvTypeId", null);
              } else if (objArr.length == 1) {
                emsIvTicketClip.setString("taxInvTypeId", (
                    (DataObject)objArr[0])
                    .getString("OCR_TYPE_ID"));
              } else {
                param.set("taxRate", 
                    Double.valueOf(dataObj.getDouble("taxRate") * 100.0D));
                objArr = 
                  DatabaseExt.queryByNamedSql(
                    "default", 
                    "com.sie.ems.mobile.ticketClip.queryOcrTypeId", 
                    param);
                if (objArr.length == 1)
                  emsIvTicketClip.setString("taxInvTypeId", (
                      (DataObject)objArr[0])
                      .getString("OCR_TYPE_ID")); 
              } 
            } 
            if (StringUtils.isBlank(emsIvTicketClip
                .getString("taxInvTypeId"))) {
              param.set("isDdefault", "Y");
              param.set("taxRate", null);
              param.set("invoiceTypeCode", null);
              param.set("attribute1", null);
              Object[] objArr = DatabaseExt.queryByNamedSql(
                  "default", 
                  "com.sie.ems.mobile.ticketClip.queryOcrTypeId", 
                  param);
              emsIvTicketClip.setString("taxInvTypeId", (
                  (DataObject)objArr[0])
                  .getString("OCR_TYPE_ID"));
            } 
            if (!imageidString.equals(""))
              imageidString = String.valueOf(emsIvTicketClip
                  .getLong("imageOcrId")); 
            DatabaseUtil.insertEntity("default", emsIvTicketClip);
            Object[] emsYxApplyOcrLists = (Object[])dataObj
              .get("emsYxApplyOcrLists");
            HashMap map = null;
            HashMapUtil mapUtil = new HashMapUtil();
            DataObject invoiceDataObject = null;
            DataObject emsIvTicketClipList = null;
            if (emsYxApplyOcrLists != null)
              for (int j = 0; j < emsYxApplyOcrLists.length; j++) {
                map = (HashMap)emsYxApplyOcrLists[j];
                invoiceDataObject = mapUtil
                  .hashMapToDataObject(map);
                try {
                  double d = 
                    Double.valueOf(invoiceDataObject
                      .get("amount").toString()).doubleValue();
                } catch (Exception e) {
                  System.err.println("发票明细行金额数据出现异常:" + e + 
                      "已做处理，设置为0");
                  invoiceDataObject.set("amount", Integer.valueOf(0));
                } 
                emsIvTicketClipList = 
                  DataObjectUtil.createDataObject("com.sie.ems.mobile.note.EmsIvTicketClipList");
                emsIvTicketClipList = 
                  DataObjectUtil.convertDataObject(
                    invoiceDataObject, 
                    "com.sie.ems.mobile.note.EmsIvTicketClipList", 
                    false);
                emsIvTicketClipList.set("imageOcrId", 
                    Long.valueOf(emsIvTicketClip.getLong("imageOcrId")));
                DataObjectUtil.setIdBySequence(
                    emsIvTicketClipList, "imageOcrListId", 
                    "EMS_IV_TICKET_CLIP_LIST_S");
                NoteUtils.setWhoFieldValue(emsIvTicketClipList, 
                    "imageOcrListId", userId);
                DatabaseUtil.insertEntity("default", 
                    emsIvTicketClipList);
              }  
            DataObject emsIvTicketClipFile = null;
            Object[] fileInfo = (Object[])dataObj.get("fileInfo");
            if (fileInfo != null) {
              byte b1;
              int j;
              Object[] arrayOfObject;
              for (j = (arrayOfObject = fileInfo).length, b1 = 0; b1 < j; ) {
                Object obj = arrayOfObject[b1];
                Map mapObj = (Map)obj;
                emsIvTicketClipFile = 
                  DataObjectUtil.createDataObject("com.sie.ems.mobile.note.EmsIvTicketClipFile");
                emsIvTicketClipFile.set("fileType", 
                    mapObj.get("fileType"));
                String fileNameString = ((String)mapObj
                  .get("fileName")).replace("\n", "");
                fileNameString = fileNameString.replace("\r\n", "");
                fileNameString = fileNameString.replace("\t", "");
                fileNameString = fileNameString.replace(" ", "");
                fileNameString = fileNameString.replaceAll(
                    "(\r\n|\r|\n|\n\r)", "");
                fileNameString = fileNameString.replaceAll("\\s*", 
                    "");
                emsIvTicketClipFile.set("fileName", fileNameString);
                emsIvTicketClipFile.set("fileUrl", fileNameString);
                emsIvTicketClipFile.set("attribute1", 
                    mapObj.get("fromFileName"));
                mapObj.get("fromFileName");
                emsIvTicketClipFile.set("imageOcrId", 
                    Long.valueOf(emsIvTicketClip.getLong("imageOcrId")));
                if (emsIvTicketClip.get("isShow") == null)
                  emsIvTicketClipFile.set("isShow", "1"); 
                DataObjectUtil.setIdBySequence(
                    emsIvTicketClipFile, "fileId", 
                    "EMS_IV_TICKET_CLIP_FILE_S");
                NoteUtils.setWhoFieldValue(emsIvTicketClipFile, 
                    "fileId", userId);
                DatabaseUtil.insertEntity("default", 
                    emsIvTicketClipFile);
                b1++;
              } 
            } 
            manager.commit();
          } 
        } catch (Exception e) {
          manager.rollback();
          e.printStackTrace();
          msg = "保存失败: " + e.getMessage();
          return NoteUtils.returnMsg(false, msg);
        } 
      } 
      b++;
    } 
    if (!state) {
      for (DataObject del : listFiles) {
        Object[] param = new Object[1];
        String fileUrl = del.getString("fileUrl");
        param[0] = fileUrl;
        Object[] params = new Object[1];
        String fileName = del.getString("fileName");
        params[0] = fileName;
        try {
          if (msg.indexOf("成功") == -1) {
            if (StringUtils.isNotBlank(fileName)) {
              System.out.println("删除附件=" + fileName);
              JavaCallLogic.callLogicBusiness(
                  "com.sie.ems.util.am.deleteYxFile", params);
            } 
            if (StringUtils.isNotBlank(fileUrl)) {
              System.out.println("删除附件=" + fileUrl);
              JavaCallLogic.callLogicBusiness(
                  "com.sie.ems.util.am.deleteYxFile", param);
            } 
          } 
        } catch (Throwable e) {
          e.printStackTrace();
        } 
      } 
      return NoteUtils.returnMsg(true, msg);
    } 
    DataObject dataObject = 
      DataObjectUtil.createDataObject("com.primeton.das.datatype.AnyType");
    dataObject.set("imageid", imageidString);
    return NoteUtils.returnMsg(true, "保存成功");
  }
  
  @Bizlet("发票编辑调用百望验真")
  public DataObject baiwangChicke(DataObject b1) {
    String noString = b1.getString("invoiceNo");
    String imageOcrId = b1.getString("imageOcrId");
    HashMap<String, String> paraMapOuname = new HashMap<String, String>();
    paraMapOuname.put("imageOcrId", imageOcrId);
    Object[] buyname = 
      DatabaseExt.queryByNamedSql("default", 
        "com.sie.ems.mobile.ticketClip.getTicketBuyname", 
        paraMapOuname);
    if (buyname != null && buyname[0] != null) {
      long chickeCodelong = 0L;
      try {
        String chickeCodeString = b1.getString("chickeCode");
        chickeCodelong = chickeCodeString.length();
      } catch (Exception exception) {}
      if (buyname[0].toString().indexOf("深圳开立") != -1 && 
        chickeCodelong != 5L) {
        HashMap<String, Object> trueorfalse = null;
        try {
          b1.set("noString", noString);
          String code = b1.getString("noString").split("-")[0];
          HashMap<String, String> paraMap = new HashMap<String, String>();
          paraMap.put("noString", code);
          Object[] alltaxamount = 
            DatabaseExt.queryByNamedSql(
              "default", 
              "com.sie.ems.mobile.ticketClip.selectInvoiceAmountForBaiwang", 
              paraMap);
          Object[] alltatoamount = 
            DatabaseExt.queryByNamedSql(
              "default", 
              "com.sie.ems.mobile.ticketClip.selectTicketInvoiceTatoAmountForBaiwang", 
              paraMap);
          double totalAmount = 0.0D;
          Double d = Double.valueOf(0.0D);
          double taxamount = 0.0D;
          if (alltaxamount.length > 1) {
            int a;
            for (a = 0; a < alltaxamount.length; a++) {
              Double sDouble = Double.valueOf(alltaxamount[a]
                  .toString());
              taxamount += sDouble.doubleValue();
            } 
            for (a = 0; a < alltatoamount.length; a++)
              totalAmount += 
                Double.valueOf(alltatoamount[a].toString()).doubleValue(); 
            DecimalFormat decimalFormat1 = new DecimalFormat("#.00");
            Double double1 = Double.valueOf(Double.parseDouble(decimalFormat1
                  .format(totalAmount)));
            double1 = Double.valueOf(totalAmount - taxamount);
            b1.set("amount", Double.valueOf(Double.parseDouble(decimalFormat1.format(double1))));
            DecimalFormat df1 = new DecimalFormat("##0.00");
            String strNum = decimalFormat1.format(totalAmount);
            System.out.println(strNum);
            b1.set("totalAmount", strNum);
          } 
          try {
            b1.set("chickeCode", b1.getString("chickeCode")
                .replace(" ", ""));
          } catch (Exception exception) {}
          DecimalFormat df = new DecimalFormat("#.00");
          b1.set("totalAmount", 
              df.format(b1.getDouble("totalAmount")));
          b1.set("invoiceNo", b1.get("originalInvoiceNo"));
          DataObject emsIvTicketClipold = null;
          String imageidString = "";
          emsIvTicketClipold = 
            DataObjectUtil.createDataObject("com.sie.ems.mobile.note.EmsIvTicketClip");
          emsIvTicketClipold.setString("imageOcrId", 
              b1.getString("imageOcrId"));
          DataObject[] objs = DatabaseUtil.queryEntitiesByTemplate(
              "default", emsIvTicketClipold);
          DataObject emsIvTicketClip = 
            DataObjectUtil.createDataObject("com.sie.ems.mobile.note.EmsIvTicketClip");
          emsIvTicketClip = objs[0];
          String longTaxNoString2 = emsIvTicketClip
            .getString("buyerTaxNo");
          b1.set("buyerTaxNo", longTaxNoString2);
          trueorfalse = OcrIoRequest.compliancecollect(b1);
        } catch (Exception e) {
          e.printStackTrace();
        } 
        if (trueorfalse.get("flag") != "T") {
          HashMap<String, String> paraMap = new HashMap<String, String>();
          String massageString = trueorfalse.get("message")
            .toString();
          String errString = "";
          errString = massageString.replace("百望远程访问错误，", "");
          if (errString.indexOf("系统异常") != -1) {
            massageString = "百望系统查询异常，请稍后再试";
          } else if (errString.indexOf("系统发生异常") != -1) {
            massageString = "百望系统查询异常，请稍后再试";
          } else if (errString.indexOf("服务调用错误") != -1) {
            massageString = "百望系统查询异常，请稍后再试";
          } else if (errString.indexOf("查验异常") != -1) {
            massageString = "百望系统查询异常，请稍后再试";
          } else if (errString.indexOf("查无此票") != -1) {
            massageString = "查无此票，税局查无此票，请检查发票信息";
          } else if (errString.indexOf("请求参数不正确") != -1 || 
            errString.indexOf("查询条件不正确") != -1 || 
            errString.indexOf("请求入参为空") != -1) {
            massageString = "请检查发票号码、代码、金额、校验码、开票日期等信息正确后再尝试";
          } else if (errString.indexOf("获取锁失败") != -1) {
            massageString = "百望系统查询异常，请稍后再试";
          } else if (errString.indexOf("Unexpected character") != -1) {
            massageString = "百望系统查询异常，请稍后再试";
          } else if (errString.indexOf("保留两位小数") != -1) {
            massageString = "请检查金额是否正确（保留两位小数）";
          } else {
            massageString = errString;
          } 
          paraMap.put("imageOcrId", b1.getString("imageOcrId"));
          paraMap.put("massageString", massageString);
          DatabaseExt.executeNamedSql("default", 
              "com.sie.ems.mobile.ticketClip.updatebaiwangfail", 
              paraMap);
        } else {
          HashMap<String, Object> allmagge = new HashMap<String, Object>();
          try {
            allmagge = OcrIoRequest.ocrCollectv2(b1);
          } catch (Exception e) {
            e.printStackTrace();
          } 
          try {
            b1.set("noString", noString);
            writeback(b1, allmagge);
          } catch (JSONException e) {
            e.printStackTrace();
          } 
        } 
      } else {
        HashMap<String, String> paraMap = new HashMap<String, String>();
        paraMap.put("imageOcrId", b1.getString("imageOcrId"));
        DatabaseExt.executeNamedSql("default", 
            "com.sie.ems.mobile.ticketClip.updatebaiwangnotbw", 
            paraMap);
      } 
    } else {
      HashMap<String, String> paraMap = new HashMap<String, String>();
      paraMap.put("imageOcrId", b1.getString("imageOcrId"));
      DatabaseExt.executeNamedSql("default", 
          "com.sie.ems.mobile.ticketClip.updatebaiwangnotbw", 
          paraMap);
    } 
    return null;
  }
  
  public void writeback(DataObject b1, HashMap<String, Object> allmagge) throws JSONException {
    DataObjectUtil.createDataObject("com.sie.ems.mobile.note.EmsIvTicketClip");
    String jsonStringList = allmagge.get("response").toString();
    JSONObject obj = new JSONObject(jsonStringList);
    JSONArray invoiceListObject = obj.getJSONArray("invoiceList");
    System.out.println("百望全片面信息明细=" + invoiceListObject);
    if (!"91440300743219767A".equals(obj.getString("purchaserTaxNo"))) {
      HashMap<String, String> paraMap = new HashMap<String, String>();
      String massageString = "百望返回税号和公司税号不一致";
      paraMap.put("imageOcrId", b1.getString("imageOcrId"));
      paraMap.put("massageString", massageString);
      DatabaseExt.executeNamedSql("default", 
          "com.sie.ems.mobile.ticketClip.updatebaiwangfail", 
          paraMap);
      return;
    } 
    int s = invoiceListObject.length();
    if (invoiceListObject.length() > 1) {
      inssertTickeByBaiwang(b1, invoiceListObject);
    } else {
      DataObject emsIvTicketClip = 
        DataObjectUtil.createDataObject("com.sie.ems.mobile.note.EmsIvTicketClip");
      DataObject emsIvTicketClip2 = 
        DataObjectUtil.createDataObject("com.sie.ems.mobile.note.EmsIvTicketClip");
      String longTaxNoString = obj.getString("purchaserTaxNo");
      DataObject emsIvTicketClipold = null;
      String imageidString = "";
      emsIvTicketClipold = 
        DataObjectUtil.createDataObject("com.sie.ems.mobile.note.EmsIvTicketClip");
      emsIvTicketClipold.setString("imageOcrId", 
          b1.getString("imageOcrId"));
      DataObject[] objs = DatabaseUtil.queryEntitiesByTemplate("default", 
          emsIvTicketClipold);
      emsIvTicketClip = objs[0];
      String longTaxNoString2 = emsIvTicketClip.getString("buyerTaxNo");
      try {
        if (!longTaxNoString2.equals(""));
      } catch (Exception e) {
        longTaxNoString2 = "91440300743219767A";
      } 
      if (longTaxNoString.equals("91440300743219767A")) {
        HashMap<String, String> hashMap = new HashMap<String, String>();
        hashMap.put("imageOcrId", b1.getString("imageOcrId"));
        DatabaseExt.executeNamedSql("default", 
            "com.sie.ems.mobile.ticketClip.updatebaiwangreturn", 
            hashMap);
      } else {
        HashMap<String, String> hashMap = new HashMap<String, String>();
        String massageString = "百望返回税号和公司税号不一致";
        hashMap.put("imageOcrId", b1.getString("imageOcrId"));
        hashMap.put("massageString", massageString);
        DatabaseExt.executeNamedSql("default", 
            "com.sie.ems.mobile.ticketClip.updatebaiwangfail", 
            hashMap);
        return;
      } 
      DecimalFormat df = new DecimalFormat("#.00");
      b1.set("totalAmount", Double.valueOf(obj.getDouble("amountTax")));
      b1.set("taxAmount", Double.valueOf(obj.getDouble("totalTax")));
      b1.set("amount", Double.valueOf(obj.getDouble("totalAmount")));
      b1.set("noString", Double.valueOf(obj.getDouble("invoiceNumber")));
      try {
        b1.set("taxRate", obj.getJSONArray("invoiceList")
            .getJSONObject(0).get("taxRate"));
      } catch (Exception exception) {}
      DataObject param = 
        DataObjectUtil.createDataObject("com.primeton.das.datatype.AnyType");
      if (b1.getString("invoiceType").indexOf("增值税电子普通发票") > -1) {
        param.set("invoiceTypeCode", b1.getString("invoiceTypeCode"));
        param.set("taxRate", Double.valueOf(b1.getDouble("taxRate") * 100.0D));
        param.set("attribute1", 
            invoiceListObject.getJSONObject(0).get("commodityName"));
        Object[] objArr = DatabaseExt.queryByNamedSql("default", 
            "com.sie.ems.mobile.ticketClip.queryOcrTypeId", param);
        if (objArr.length > 0)
          b1.setString("taxInvTypeId", (
              (DataObject)objArr[0]).getString("OCR_TYPE_ID")); 
      } else {
        param.set("invoiceTypeCode", b1.getString("invoiceTypeCode"));
        Object[] objArr = DatabaseExt.queryByNamedSql("default", 
            "com.sie.ems.mobile.ticketClip.queryOcrTypeId", param);
        if (objArr.length == 0) {
          b1.setString("taxInvTypeId", null);
        } else if (objArr.length == 1) {
          b1.setString("taxInvTypeId", (
              (DataObject)objArr[0]).getString("OCR_TYPE_ID"));
        } else {
          param.set("taxRate", Double.valueOf(b1.getDouble("taxRate") * 100.0D));
          objArr = DatabaseExt.queryByNamedSql("default", 
              "com.sie.ems.mobile.ticketClip.queryOcrTypeId", 
              param);
          if (objArr.length == 1)
            b1.setString("taxInvTypeId", ((DataObject)objArr[0])
                .getString("OCR_TYPE_ID")); 
        } 
      } 
      if (StringUtils.isBlank(b1.getString("taxInvTypeId"))) {
        param.set("isDdefault", "Y");
        param.set("taxRate", null);
        param.set("invoiceTypeCode", null);
        param.set("attribute1", null);
        Object[] objArr = DatabaseExt.queryByNamedSql("default", 
            "com.sie.ems.mobile.ticketClip.queryOcrTypeId", param);
        b1.setString("taxInvTypeId", (
            (DataObject)objArr[0]).getString("OCR_TYPE_ID"));
      } 
      b1.set("ticketStatus", "BWSUCCESS");
      b1.set("attribute9", "验证成功");
      emsIvTicketClip2 = DataObjectUtil.convertDataObject(b1, 
          "com.sie.ems.mobile.note.EmsIvTicketClip", false);
      DatabaseUtil.updateEntity("default", emsIvTicketClip2);
      HashMap<String, String> paraMap = new HashMap<String, String>();
      paraMap.put("imageOcrId", b1.getString("imageOcrId"));
      DatabaseExt.executeNamedSql("default", 
          "com.sie.ems.mobile.ticketClip.deleteTickeList", paraMap);
      List<DataObject> saveListL = new ArrayList<DataObject>();
      for (int i = 0; i < invoiceListObject.length(); i++) {
        JSONObject listobject = invoiceListObject.getJSONObject(i);
        DataObject emsIvTicketClipList = 
          DataObjectUtil.createDataObject("com.sie.ems.mobile.note.EmsIvTicketClipList");
        emsIvTicketClipList.set("imageOcrId", Long.valueOf(b1.getLong("imageOcrId")));
        emsIvTicketClipList.set("lineNumber", listobject.get("rowNo"));
        emsIvTicketClipList.set("goods", 
            listobject.get("commodityName"));
        emsIvTicketClipList.set("amount", listobject.get("amount"));
        emsIvTicketClipList.set("taxRate", listobject.get("taxRate"));
        emsIvTicketClipList.set("taxAmount", listobject.get("tax"));
        try {
          emsIvTicketClipList.set("unit", listobject.get("type"));
          emsIvTicketClipList.set("models", 
              listobject.get("licensePlateNum"));
        } catch (Exception exception) {}
        DataObjectUtil.setIdBySequence(
            emsIvTicketClipList, "imageOcrListId", 
            "EMS_IV_TICKET_CLIP_LIST_S");
        saveListL.add(emsIvTicketClipList);
      } 
      DataObject[] saveListList = DataObjectUtil.convertDataObjects(
          saveListL, "com.sie.ems.mobile.note.EmsIvTicketClipList", 
          true);
      DatabaseUtil.saveEntities("default", saveListList);
    } 
  }
  
  public void inssertTickeByBaiwang(DataObject b1, JSONArray invoiceListObject) throws JSONException {
    HashMapUtil mapUtil1 = new HashMapUtil();
    Map<String, JSONObject> tatemMap = new HashMap<String, JSONObject>();
    List<Object> list = new ArrayList();
    for (int z = 0; z < invoiceListObject.length(); z++)
      list.add(invoiceListObject.get(z)); 
    Object[] savedatas = list.toArray();
    List<DataObject> list2 = new ArrayList<DataObject>();
    CollectionUtils.addAll(list2, savedatas);
    for (int i = 0; i < list2.size(); i++) {
      HashMap<String, Object> map2 = null;
      JSONObject invoiceDataObject2 = (JSONObject)list2.get(i);
      try {
        if (invoiceDataObject2.getString("commodityName").indexOf("详见销货清单") != -1)
          continue; 
      } catch (Exception exception) {}
      boolean flag = tatemMap.containsKey(invoiceDataObject2
          .getString("taxRate"));
      if (!flag) {
        tatemMap.put(invoiceDataObject2.getString("taxRate"), 
            invoiceDataObject2);
      } else {
        JSONObject keyValueDataObject = tatemMap.get(invoiceDataObject2
            .getString("taxRate"));
        double amount = keyValueDataObject.getDouble("amount") + 
          invoiceDataObject2.getDouble("amount");
        DecimalFormat df = new DecimalFormat("#.00");
        keyValueDataObject.put("amount", df.format(amount));
        double taxAmount = keyValueDataObject.getDouble("tax") + 
          invoiceDataObject2.getDouble("tax");
        keyValueDataObject.put("tax", df.format(taxAmount));
        tatemMap.put(invoiceDataObject2.getString("taxRate"), 
            keyValueDataObject);
      } 
      continue;
    } 
    DataObject emsIvTicketClipold = null;
    String imageidString = "";
    emsIvTicketClipold = 
      DataObjectUtil.createDataObject("com.sie.ems.mobile.note.EmsIvTicketClip");
    emsIvTicketClipold.setString("imageOcrId", b1.getString("imageOcrId"));
    DataObject[] objs = DatabaseUtil.queryEntitiesByTemplate("default", 
        emsIvTicketClipold);
    DataObject emsIvTicketClipFile = 
      DataObjectUtil.createDataObject("com.sie.ems.mobile.note.EmsIvTicketClipFile");
    emsIvTicketClipFile.setString("imageOcrId", b1.getString("imageOcrId"));
    DataObject[] objsFile = DatabaseUtil.queryEntitiesByTemplate("default", 
        emsIvTicketClipFile);
    String code = b1.getString("noString").split("-")[0];
    HashMap<String, String> paraMap = new HashMap<String, String>();
    paraMap.put("noString", code);
    Object[] imageOcrid = 
      DatabaseExt.queryByNamedSql(
        "default", 
        "com.sie.ems.mobile.ticketClip.selectTicketInvoiceIdForBaiwang", 
        paraMap);
    TransactionService manager = 
      (TransactionService)WFServiceFactory.getService(TransactionService.class);
    manager.begin();
    String keyString = "";
    try {
      for (String entry : tatemMap.keySet()) {
        JSONObject invoiceDataObject1 = null;
        invoiceDataObject1 = tatemMap
          .get(entry.toString());
        DataObject emsIvTicketClip = 
          DataObjectUtil.createDataObject("com.sie.ems.mobile.note.EmsIvTicketClip");
        DataObject emsIvTicketClip2 = 
          DataObjectUtil.createDataObject("com.sie.ems.mobile.note.EmsIvTicketClip");
        emsIvTicketClip = objs[0];
        emsIvTicketClip.set("invoiceNo", 
            emsIvTicketClip.get("originalInvoiceNo") + "-" + 
            invoiceDataObject1.get("taxRate"));
        Double s = Double.valueOf(invoiceDataObject1.get("amount")
            .toString());
        DecimalFormat df = new DecimalFormat("#0.00");
        Double taxRate = Double.valueOf(Double.parseDouble(df
              .format(invoiceDataObject1.getDouble("taxRate"))));
        emsIvTicketClip.set("taxRate", df.format(taxRate));
        Double taxADouble = Double.valueOf(Double.parseDouble(df
              .format(invoiceDataObject1.getDouble("tax"))));
        emsIvTicketClip.set("taxAmount", df.format(taxADouble));
        Double aaDouble = Double.valueOf(invoiceDataObject1.getDouble("amount"));
        Double dd = Double.valueOf(invoiceDataObject1.getDouble("tax"));
        Double aDouble = aaDouble;
        Double amount = aDouble;
        emsIvTicketClip.set("amount", amount.toString());
        try {
          String s1 = invoiceDataObject1.getString("totalAmount");
          Double totaDouble = 
            Double.valueOf(Double.parseDouble(df.format(invoiceDataObject1
                  .getDouble("totalAmount"))));
          emsIvTicketClip.set("totalAmount", df.format(totaDouble));
        } catch (Exception e) {
          emsIvTicketClip
            .set("totalAmount", df.format(aaDouble.doubleValue() + dd.doubleValue()));
        } 
        DataObject param = 
          DataObjectUtil.createDataObject("com.primeton.das.datatype.AnyType");
        if (emsIvTicketClip.getString("invoiceType").indexOf(
            "增值税电子普通发票") > -1) {
          param.set("invoiceTypeCode", 
              emsIvTicketClip.getString("invoiceTypeCode"));
          param.set("taxRate", 
              Double.valueOf(emsIvTicketClip.getDouble("taxRate") * 100.0D));
          param.set("attribute1", 
              invoiceDataObject1.get("commodityName"));
          Object[] objArr = DatabaseExt.queryByNamedSql("default", 
              "com.sie.ems.mobile.ticketClip.queryOcrTypeId", 
              param);
          if (objArr.length > 0)
            emsIvTicketClip.setString("taxInvTypeId", (
                (DataObject)objArr[0])
                .getString("OCR_TYPE_ID")); 
        } else {
          param.set("invoiceTypeCode", 
              emsIvTicketClip.getString("invoiceTypeCode"));
          Object[] objArr = DatabaseExt.queryByNamedSql("default", 
              "com.sie.ems.mobile.ticketClip.queryOcrTypeId", 
              param);
          if (objArr.length == 0) {
            emsIvTicketClip.setString("taxInvTypeId", null);
          } else if (objArr.length == 1) {
            emsIvTicketClip.setString("taxInvTypeId", (
                (DataObject)objArr[0])
                .getString("OCR_TYPE_ID"));
          } else {
            param.set("taxRate", 
                Double.valueOf(emsIvTicketClip.getDouble("taxRate") * 100.0D));
            objArr = DatabaseExt.queryByNamedSql("default", 
                "com.sie.ems.mobile.ticketClip.queryOcrTypeId", 
                param);
            if (objArr.length == 1)
              emsIvTicketClip.setString("taxInvTypeId", (
                  (DataObject)objArr[0])
                  .getString("OCR_TYPE_ID")); 
          } 
        } 
        if (StringUtils.isBlank(emsIvTicketClip
            .getString("taxInvTypeId"))) {
          param.set("isDdefault", "Y");
          param.set("taxRate", null);
          param.set("invoiceTypeCode", null);
          param.set("attribute1", null);
          Object[] objArr = DatabaseExt.queryByNamedSql("default", 
              "com.sie.ems.mobile.ticketClip.queryOcrTypeId", 
              param);
          emsIvTicketClip
            .setString("taxInvTypeId", (
              (DataObject)objArr[0])
              .getString("OCR_TYPE_ID"));
        } 
        emsIvTicketClip2 = DataObjectUtil.convertDataObject(
            emsIvTicketClip, 
            "com.sie.ems.mobile.note.EmsIvTicketClip", false);
        emsIvTicketClip2.set("imageOcrId", "");
        emsIvTicketClip2.set("attribute9", "验证成功");
        DataObjectUtil.setIdBySequence(
            emsIvTicketClip2, "imageOcrId", "EMS_IV_TICKET_CLIP_S");
        keyString = emsIvTicketClip2.getString("imageOcrId");
        DatabaseUtil.insertEntity("default", emsIvTicketClip2);
        DataObject emsIvTicketClipList = 
          DataObjectUtil.createDataObject("com.sie.ems.mobile.note.EmsIvTicketClipList");
        emsIvTicketClipList.set("imageOcrId", 
            Long.valueOf(emsIvTicketClip2.getLong("imageOcrId")));
        emsIvTicketClipList.set("lineNumber", 
            invoiceDataObject1.get("rowNo"));
        emsIvTicketClipList.set("goods", 
            invoiceDataObject1.get("commodityName"));
        emsIvTicketClipList.set("amount", 
            invoiceDataObject1.get("amount"));
        emsIvTicketClipList.set("taxRate", 
            invoiceDataObject1.get("taxRate"));
        emsIvTicketClipList.set("taxAmount", 
            invoiceDataObject1.get("tax"));
        emsIvTicketClipList.set("imageOcrListId", "");
        DataObjectUtil.setIdBySequence(
            emsIvTicketClipList, "imageOcrListId", 
            "EMS_IV_TICKET_CLIP_LIST_S");
        DatabaseUtil.insertEntity("default", emsIvTicketClipList);
        DataObject emsIvTicketClipFileNew = 
          DataObjectUtil.createDataObject("com.sie.ems.mobile.note.EmsIvTicketClipFile");
        emsIvTicketClipFileNew = objsFile[0];
        emsIvTicketClipFileNew.set("imageOcrId", 
            Long.valueOf(emsIvTicketClip2.getLong("imageOcrId")));
        emsIvTicketClipFileNew.set("fileId", "");
        DataObjectUtil.setIdBySequence(
            emsIvTicketClipFileNew, "fileId", 
            "EMS_IV_TICKET_CLIP_FILE_S");
        NoteUtils.setWhoFieldValue(emsIvTicketClipFileNew, "fileId", 
            "4001");
        DatabaseUtil.insertEntity("default", emsIvTicketClipFileNew);
        HashMap<String, String> paraMap1 = new HashMap<String, String>();
        paraMap1.put("imageOcrId", keyString);
        DatabaseExt.executeNamedSql("default", 
            "com.sie.ems.mobile.ticketClip.updatebaiwangreturn", 
            paraMap1);
      } 
    } catch (Exception e) {
      System.err.println(e.getMessage());
      manager.rollback();
      return;
    } 
    for (int o = 0; o < imageOcrid.length; o++) {
      HashMap<String, String> paraMap1 = new HashMap<String, String>();
      paraMap1.put("imageOcrId", imageOcrid[o].toString());
      DatabaseExt.executeNamedSql("default", 
          "com.sie.ems.mobile.ticketClip.deleteTickeList", paraMap1);
      DatabaseExt.executeNamedSql("default", 
          "com.sie.ems.mobile.ticketClip.deleteTicke", paraMap1);
    } 
    manager.commit();
  }
  
  public DataObject insertTickeForMoreTate(DataObject dataObj, String userId) {
    Object[] emsYxApplylistsForOcrL = (Object[])dataObj
      .get("emsYxApplyOcrLists");
    HashMapUtil mapUtil1 = new HashMapUtil();
    DataObject invoiceDataObject1 = null;
    Map<String, DataObject> tatemMap = new HashMap<String, DataObject>();
    int z;
    for (z = 0; z < emsYxApplylistsForOcrL.length; z++) {
      HashMap<String, Object> map2 = null;
      DataObject invoiceDataObject2 = null;
      map2 = (HashMap<String, Object>)emsYxApplylistsForOcrL[z];
      invoiceDataObject2 = mapUtil1.hashMapToDataObject(map2);
      try {
        if ("详见销货清单".equals(invoiceDataObject2.getString("commodityName")))
          continue; 
      } catch (Exception exception) {}
      String s = invoiceDataObject2.getString("taxRate");
      if (s == null)
        invoiceDataObject2.set("taxRate", dataObj.getString("taxRate")); 
      boolean flag = tatemMap.containsKey(invoiceDataObject2
          .getString("taxRate"));
      if (!flag) {
        tatemMap.put(invoiceDataObject2.getString("taxRate"), 
            invoiceDataObject2);
      } else {
        DataObject keyValueDataObject = tatemMap
          .get(invoiceDataObject2.getString("taxRate"));
        Float amount = Float.valueOf(keyValueDataObject.getFloat("amount") + 
            invoiceDataObject2.getFloat("amount"));
        if (invoiceDataObject2.getString("taxAmount") != null) {
          DecimalFormat decimalFormat = new DecimalFormat("#.00");
          Float taxAmount = Float.valueOf(keyValueDataObject
              .getFloat("taxAmount") + 
              invoiceDataObject2.getFloat("taxAmount"));
          keyValueDataObject.set("taxAmount", 
              Double.valueOf(Double.parseDouble(decimalFormat.format(taxAmount))));
        } 
        DecimalFormat df = new DecimalFormat("#.00");
        keyValueDataObject.set("amount", 
            Double.valueOf(Double.parseDouble(df.format(amount))));
        tatemMap.put(invoiceDataObject2.getString("taxRate"), 
            keyValueDataObject);
      } 
      continue;
    } 
    z = 0;
    boolean sate = true;
    String msg = "";
    for (String entry : tatemMap.keySet()) {
      invoiceDataObject1 = tatemMap.get(entry.toString());
      DataObject emsIvTicketClip = null;
      String imageidString = "";
      emsIvTicketClip = 
        DataObjectUtil.createDataObject("com.sie.ems.mobile.note.EmsIvTicketClip");
      TransactionService manager = 
        (TransactionService)WFServiceFactory.getService(TransactionService.class);
      manager.begin();
      try {
        emsIvTicketClip.setString("invoiceCode", 
            dataObj.getString("invoiceCode"));
        emsIvTicketClip.setString("invoiceNo", 
            String.valueOf(dataObj.getString("invoiceNo")) + "-" + 
            invoiceDataObject1.getString("taxRate"));
        DataObject[] objs = DatabaseUtil.queryEntitiesByTemplate(
            "default", emsIvTicketClip);
        DataObject emsEinvs = 
          DataObjectUtil.createDataObject("com.sie.ems.dataset.ec.EmsEcFeeEinv");
        emsEinvs.setString("eCode", dataObj.getString("invoiceCode"));
        emsEinvs.setString("eNum", String.valueOf(dataObj.getString("invoiceNo")) + "-" + 
            invoiceDataObject1.getString("taxRate"));
        DataObject[] einvs = DatabaseUtil.queryEntitiesByTemplate(
            "default", emsEinvs);
        if ((objs != null && objs.length > 0) || (
          einvs != null && einvs.length > 0)) {
          msg = String.valueOf(msg) + "发票号码：" + dataObj.getString("invoiceNo") + "-" + 
            invoiceDataObject1.getString("taxRate") + 
            "保存失败(已存在)，";
          sate = false;
          manager.rollback();
          continue;
        } 
        msg = String.valueOf(msg) + "发票号码：" + dataObj.getString("invoiceNo") + "-" + 
          invoiceDataObject1.getString("taxRate") + "保存成功，";
        if (StringUtils.isBlank(dataObj.getString("deductibleamount")) || 
          dataObj.getString("deductibleamount").equals("null"))
          dataObj.set("deductibleamount", Integer.valueOf(0)); 
        if (StringUtils.isBlank(invoiceDataObject1.getString("amount")) || 
          invoiceDataObject1.getString("amount")
          .equals("null")) {
          dataObj.set("totalAmount", Integer.valueOf(0));
        } else {
          dataObj.set("totalAmount", 
              invoiceDataObject1.getString("amount"));
        } 
        if (StringUtils.isBlank(invoiceDataObject1.getString("taxRate")) || 
          invoiceDataObject1.getString("taxRate").equals(
            "null")) {
          dataObj.set("taxRate", Integer.valueOf(0));
        } else {
          dataObj.set("taxRate", 
              invoiceDataObject1.getString("taxRate"));
        } 
        DecimalFormat df = new DecimalFormat("#.00");
        Double s = Double.valueOf(dataObj.getString("totalAmount"));
        Double s1 = Double.valueOf(dataObj.getString("taxRate"));
        Double taxAmount = Double.valueOf(s.doubleValue() * s1.doubleValue());
        double amount = 
          Double.valueOf(dataObj.getDouble("totalAmount")).doubleValue();
        double amount1 = Double.parseDouble(df.format(amount));
        dataObj.set("amount", Double.valueOf(amount1));
        dataObj.set("taxAmount", Double.valueOf(Double.parseDouble(df
                .format(invoiceDataObject1.getFloat("taxAmount")))));
        double totalAmount = Double.valueOf(dataObj
            .getDouble("totalAmount")).doubleValue() + 
          Double.parseDouble(df.format(invoiceDataObject1
              .getFloat("taxAmount")));
        double totalAmount1 = 
          Double.parseDouble(df.format(totalAmount));
        dataObj.set("totalAmount", Double.valueOf(totalAmount1));
        if (StringUtils.isBlank(dataObj.getString("otherTax")) || 
          dataObj.getString("otherTax").equals("null"))
          dataObj.set("otherTax", Integer.valueOf(0)); 
        String code = dataObj.getString("invoiceTypeCode");
        if (code.equals("999"))
          dataObj.set("attribute3", Long.valueOf(Long.parseLong(code))); 
        dataObj.getString("invoiceCheckCode");
        dataObj.set("attribute10", 
            dataObj.getString("invoiceCheckCode"));
        dataObj.set("ticketStatus", "N");
        if (z == 0)
          dataObj.set("originalInvoiceNo", 
              dataObj.getString("invoiceNo")); 
        dataObj.set("invoiceNo", String.valueOf(dataObj.getString("invoiceNo")) + "-" + 
            invoiceDataObject1.getString("taxRate"));
        if (z != 0)
          dataObj.set("invoiceNo", 
              String.valueOf(dataObj.getString("originalInvoiceNo")) + "-" + 
              invoiceDataObject1.getString("taxRate")); 
        z++;
        emsIvTicketClip = DataObjectUtil.convertDataObject(dataObj, 
            "com.sie.ems.mobile.note.EmsIvTicketClip", false);
        DataObjectUtil.setIdBySequence(
            emsIvTicketClip, "imageOcrId", "EMS_IV_TICKET_CLIP_S");
        NoteUtils.setWhoFieldValue(emsIvTicketClip, "imageOcrId", 
            userId);
        emsIvTicketClip.setString("ocrReimType", 
            dataObj.getString("taxInvTypeId"));
        emsIvTicketClip.setString("taxInvTypeId", null);
        String taxinvtypeidname = "f";
        try {
          taxinvtypeidname = dataObj.getString("taxinvtypeidname");
        } catch (Exception e) {
          taxinvtypeidname = "s";
        } 
        DataObject param = 
          DataObjectUtil.createDataObject("com.primeton.das.datatype.AnyType");
        if (dataObj.getString("invoiceType").indexOf("增值税电子普通发票") > -1) {
          param.set("invoiceTypeCode", 
              dataObj.getString("invoiceTypeCode"));
          param.set("taxRate", Double.valueOf(dataObj.getDouble("taxRate") * 100.0D));
          Object[] arrayOfObject = (Object[])dataObj
            .get("emsYxApplyOcrLists");
          for (int i = 0; i < arrayOfObject.length; i++) {
            HashMap hashMap = (HashMap)arrayOfObject[i];
            param.set("attribute1", hashMap.get("goods"));
            Object[] objArr = DatabaseExt.queryByNamedSql(
                "default", 
                "com.sie.ems.mobile.ticketClip.queryOcrTypeId", 
                param);
            if (objArr.length > 0) {
              emsIvTicketClip.setString("taxInvTypeId", (
                  (DataObject)objArr[0])
                  .getString("OCR_TYPE_ID"));
              break;
            } 
          } 
        } else {
          param.set("invoiceTypeCode", 
              dataObj.getString("invoiceTypeCode"));
          Object[] objArr = DatabaseExt.queryByNamedSql("default", 
              "com.sie.ems.mobile.ticketClip.queryOcrTypeId", 
              param);
          if (objArr.length == 0) {
            emsIvTicketClip.setString("taxInvTypeId", null);
          } else if (objArr.length == 1) {
            emsIvTicketClip.setString("taxInvTypeId", (
                (DataObject)objArr[0])
                .getString("OCR_TYPE_ID"));
          } else {
            param.set("taxRate", Double.valueOf(dataObj.getDouble("taxRate") * 100.0D));
            objArr = DatabaseExt.queryByNamedSql("default", 
                "com.sie.ems.mobile.ticketClip.queryOcrTypeId", 
                param);
            if (objArr.length == 1)
              emsIvTicketClip.setString("taxInvTypeId", (
                  (DataObject)objArr[0])
                  .getString("OCR_TYPE_ID")); 
          } 
        } 
        if (taxinvtypeidname != null)
          try {
            emsIvTicketClip.setString("taxInvTypeId", 
                taxinvtypeidname);
            emsIvTicketClip.setString("taxRate", 
                dataObj.getString("taxRate"));
          } catch (Exception exception) {} 
        if (StringUtils.isBlank(emsIvTicketClip
            .getString("taxInvTypeId"))) {
          param.set("isDdefault", "Y");
          param.set("taxRate", null);
          param.set("invoiceTypeCode", null);
          param.set("attribute1", null);
          Object[] objArr = DatabaseExt.queryByNamedSql("default", 
              "com.sie.ems.mobile.ticketClip.queryOcrTypeId", 
              param);
          emsIvTicketClip
            .setString("taxInvTypeId", (
              (DataObject)objArr[0])
              .getString("OCR_TYPE_ID"));
        } 
        if (!imageidString.equals(""))
          imageidString = String.valueOf(emsIvTicketClip
              .getLong("imageOcrId")); 
        DatabaseUtil.insertEntity("default", emsIvTicketClip);
        Object[] emsYxApplyOcrLists = (Object[])dataObj
          .get("emsYxApplyOcrLists");
        HashMap map = null;
        HashMapUtil mapUtil = new HashMapUtil();
        DataObject invoiceDataObject = null;
        DataObject emsIvTicketClipList = null;
        if (emsYxApplyOcrLists != null) {
          map = (HashMap)emsYxApplyOcrLists[0];
          invoiceDataObject = tatemMap.get(entry
              .toString());
          emsIvTicketClipList = 
            DataObjectUtil.createDataObject("com.sie.ems.mobile.note.EmsIvTicketClipList");
          emsIvTicketClipList = DataObjectUtil.convertDataObject(
              invoiceDataObject, 
              "com.sie.ems.mobile.note.EmsIvTicketClipList", 
              false);
          emsIvTicketClipList.set("imageOcrId", 
              Long.valueOf(emsIvTicketClip.getLong("imageOcrId")));
          DataObjectUtil.setIdBySequence(
              emsIvTicketClipList, "imageOcrListId", 
              "EMS_IV_TICKET_CLIP_LIST_S");
          NoteUtils.setWhoFieldValue(emsIvTicketClipList, 
              "imageOcrListId", userId);
          DatabaseUtil.insertEntity("default", emsIvTicketClipList);
        } 
        DataObject emsIvTicketClipFile = null;
        Object[] fileInfo = (Object[])dataObj.get("fileInfo");
        if (fileInfo != null) {
          byte b;
          int i;
          Object[] arrayOfObject;
          for (i = (arrayOfObject = fileInfo).length, b = 0; b < i; ) {
            Object obj = arrayOfObject[b];
            Map mapObj = (Map)obj;
            emsIvTicketClipFile = 
              DataObjectUtil.createDataObject("com.sie.ems.mobile.note.EmsIvTicketClipFile");
            emsIvTicketClipFile.set("fileType", 
                mapObj.get("fileType"));
            String fileNameString = ((String)mapObj
              .get("fileName")).replace("\n", "");
            fileNameString = fileNameString = fileNameString
              .replace("\r\n", "");
            fileNameString = fileNameString.replace("\t", "");
            fileNameString = fileNameString.replace(" ", "");
            fileNameString = fileNameString.replaceAll(
                "(\r\n|\r|\n|\n\r)", "");
            fileNameString = fileNameString.replaceAll("\\s*", "");
            emsIvTicketClipFile.set("fileName", fileNameString);
            emsIvTicketClipFile.set("fileUrl", fileNameString);
            emsIvTicketClipFile.set("attribute1", 
                mapObj.get("fromFileName"));
            mapObj.get("fromFileName");
            emsIvTicketClipFile.set("imageOcrId", 
                Long.valueOf(emsIvTicketClip.getLong("imageOcrId")));
            if (emsIvTicketClip.get("isShow") == null)
              emsIvTicketClipFile.set("isShow", "1"); 
            DataObjectUtil.setIdBySequence(
                emsIvTicketClipFile, "fileId", 
                "EMS_IV_TICKET_CLIP_FILE_S");
            NoteUtils.setWhoFieldValue(emsIvTicketClipFile, 
                "fileId", userId);
            DatabaseUtil.insertEntity("default", 
                emsIvTicketClipFile);
            b++;
          } 
        } 
        manager.commit();
      } catch (Exception e) {
        manager.rollback();
        e.printStackTrace();
        msg = "保存失败: " + e.getMessage();
        return NoteUtils.returnMsg(false, msg);
      } 
    } 
    if (!sate)
      return NoteUtils.returnMsg(false, msg); 
    return NoteUtils.returnMsg(true, msg);
  }
}
